Linux anchor 4.4.0-210-generic #242-Ubuntu SMP Fri Apr 16 09:57:56 UTC 2021 x86_64
Apache/2.4.18 (Ubuntu)
Server IP : 10.10.100.4 & Your IP : 216.73.217.150
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
sbin /
Delete
Unzip
Name
Size
Permission
Date
Action
MAKEDEV
51.24
KB
-rwxr-xr-x
2017-03-27 10:01
acpi_available
112
B
-rwxr-xr-x
2014-05-01 17:56
agetty
43.07
KB
-rwxr-xr-x
2020-01-27 15:28
apm_available
125
B
-rwxr-xr-x
2014-05-01 18:05
apparmor_parser
1.23
MB
-rwxr-xr-x
2023-06-29 13:30
badblocks
26.59
KB
-rwxr-xr-x
2020-01-22 15:42
blkdiscard
22.54
KB
-rwxr-xr-x
2020-01-27 15:28
blkid
79.39
KB
-rwxr-xr-x
2020-01-27 15:28
blockdev
34.79
KB
-rwxr-xr-x
2020-01-27 15:28
bridge
62.73
KB
-rwxr-xr-x
2019-04-16 14:37
capsh
18.59
KB
-rwxr-xr-x
2015-10-23 23:11
cfdisk
84.38
KB
-rwxr-xr-x
2020-01-27 15:28
cgdisk
170.17
KB
-rwxr-xr-x
2016-02-07 11:06
chcpu
22.52
KB
-rwxr-xr-x
2020-01-27 15:28
crda
10.3
KB
-rwxr-xr-x
2014-11-18 15:57
cryptdisks_start
1.11
KB
-rwxr-xr-x
2017-09-06 12:08
cryptdisks_stop
1.16
KB
-rwxr-xr-x
2017-09-06 12:08
cryptsetup
57.93
KB
-rwxr-xr-x
2017-09-06 12:08
cryptsetup-reencrypt
40.3
KB
-rwxr-xr-x
2017-09-06 12:08
ctrlaltdel
10.34
KB
-rwxr-xr-x
2020-01-27 15:28
debugfs
146.74
KB
-rwxr-xr-x
2020-01-22 15:42
depmod
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
dhclient
475.83
KB
-rwxr-xr-x
2018-03-05 13:18
dhclient-script
15.28
KB
-rwxr-xr-x
2018-03-05 13:18
dmeventd
42.07
KB
-rwxr-xr-x
2016-04-16 09:58
dmsetup
146.02
KB
-rwxr-xr-x
2016-04-16 09:57
dosfsck
58.08
KB
-rwxr-xr-x
2016-05-26 14:21
dosfslabel
54.08
KB
-rwxr-xr-x
2016-05-26 14:21
dumpe2fs
22.59
KB
-rwxr-xr-x
2020-01-22 15:42
e2fsck
250.93
KB
-rwxr-xr-x
2020-01-22 15:42
e2image
30.75
KB
-rwxr-xr-x
2020-01-22 15:42
e2label
75.55
KB
-rwxr-xr-x
2020-01-22 15:42
e2undo
10.41
KB
-rwxr-xr-x
2020-01-22 15:42
ethtool
267.37
KB
-rwxr-xr-x
2016-04-01 15:07
fatlabel
54.08
KB
-rwxr-xr-x
2016-05-26 14:21
fdisk
107.06
KB
-rwxr-xr-x
2020-01-27 15:28
findfs
10.33
KB
-rwxr-xr-x
2020-01-27 15:28
fixparts
58.17
KB
-rwxr-xr-x
2016-02-07 11:06
fsadm
14.07
KB
-rwxr-xr-x
2016-04-16 09:57
fsck
43.15
KB
-rwxr-xr-x
2020-01-27 15:28
fsck.cramfs
34.77
KB
-rwxr-xr-x
2020-01-27 15:28
fsck.ext2
250.93
KB
-rwxr-xr-x
2020-01-22 15:42
fsck.ext3
250.93
KB
-rwxr-xr-x
2020-01-22 15:42
fsck.ext4
250.93
KB
-rwxr-xr-x
2020-01-22 15:42
fsck.ext4dev
250.93
KB
-rwxr-xr-x
2020-01-22 15:42
fsck.fat
58.08
KB
-rwxr-xr-x
2016-05-26 14:21
fsck.minix
75.09
KB
-rwxr-xr-x
2020-01-27 15:28
fsck.msdos
58.08
KB
-rwxr-xr-x
2016-05-26 14:21
fsck.nfs
333
B
-rwxr-xr-x
2016-02-05 10:48
fsck.vfat
58.08
KB
-rwxr-xr-x
2016-05-26 14:21
fsck.xfs
433
B
-rwxr-xr-x
2017-09-08 22:23
fsfreeze
10.37
KB
-rwxr-xr-x
2020-01-27 15:28
fstab-decode
6.21
KB
-rwxr-xr-x
2016-02-05 10:48
fstrim
38.97
KB
-rwxr-xr-x
2020-01-27 15:28
gdisk
178.17
KB
-rwxr-xr-x
2016-02-07 11:06
getcap
10.27
KB
-rwxr-xr-x
2015-10-23 23:11
getpcaps
10.24
KB
-rwxr-xr-x
2015-10-23 23:11
getty
43.07
KB
-rwxr-xr-x
2020-01-27 15:28
halt
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
hdparm
119.93
KB
-rwxr-xr-x
2018-03-22 20:37
hwclock
54.91
KB
-rwxr-xr-x
2020-01-27 15:28
ifconfig
66.45
KB
-rwxr-xr-x
2014-06-30 15:19
ifdown
65.95
KB
-rwxr-xr-x
2018-05-10 16:21
ifenslave
3.44
KB
-rwxr-xr-x
2015-07-24 17:45
ifenslave-2.6
3.44
KB
-rwxr-xr-x
2015-07-24 17:45
ifquery
65.95
KB
-rwxr-xr-x
2018-05-10 16:21
ifup
65.95
KB
-rwxr-xr-x
2018-05-10 16:21
init
1.52
MB
-rwxr-xr-x
2021-04-02 17:51
insmod
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
installkernel
2.58
KB
-rwxr-xr-x
2016-01-26 19:17
ip
367.38
KB
-rwxr-xr-x
2019-04-16 14:37
ip6tables
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
ip6tables-restore
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
ip6tables-save
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
ipmaddr
18.32
KB
-rwxr-xr-x
2014-06-30 15:19
iptables
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
iptables-restore
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
iptables-save
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
iptunnel
22.33
KB
-rwxr-xr-x
2014-06-30 15:19
iscsi-iname
13.99
KB
-rwxr-xr-x
2018-12-11 21:12
iscsi_discovery
5.16
KB
-rwxr-xr-x
2013-09-12 09:01
iscsiadm
737.26
KB
-rwxr-xr-x
2018-12-11 21:12
iscsid
765.61
KB
-rwxr-xr-x
2018-12-11 21:12
iscsistart
321.29
KB
-rwxr-xr-x
2018-12-11 21:12
isosize
22.53
KB
-rwxr-xr-x
2020-01-27 15:28
iw
173.63
KB
-rwxr-xr-x
2014-10-24 11:07
kbdrate
10.37
KB
-rwxr-xr-x
2016-09-22 19:33
key.dns_resolver
18.07
KB
-rwxr-xr-x
2015-12-10 17:41
killall5
18.61
KB
-rwxr-xr-x
2016-02-05 10:48
ldconfig
387
B
-rwxr-xr-x
2021-04-21 20:14
ldconfig.real
977.16
KB
-rwxr-xr-x
2021-04-21 20:14
logsave
10.35
KB
-rwxr-xr-x
2020-01-22 15:42
losetup
71.21
KB
-rwxr-xr-x
2020-01-27 15:28
lsmod
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
lvchange
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvconvert
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvcreate
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvdisplay
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvextend
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvm
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvmchange
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvmconf
12.39
KB
-rwxr-xr-x
2016-04-16 09:57
lvmconfig
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvmdiskscan
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvmdump
9.31
KB
-rwxr-xr-x
2016-04-16 09:57
lvmetad
50.13
KB
-rwxr-xr-x
2016-04-16 09:58
lvmpolld
59.52
KB
-rwxr-xr-x
2016-04-16 09:58
lvmsadc
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvmsar
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvreduce
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvremove
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvrename
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvresize
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvs
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
lvscan
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
mdadm
501.19
KB
-rwxr-xr-x
2017-11-08 14:18
mdmon
311.8
KB
-rwxr-xr-x
2017-11-08 14:18
mii-tool
18.81
KB
-rwxr-xr-x
2014-06-30 15:19
mkdosfs
26.49
KB
-rwxr-xr-x
2016-05-26 14:21
mke2fs
103.9
KB
-rwxr-xr-x
2020-01-22 15:42
mkfs
10.34
KB
-rwxr-xr-x
2020-01-27 15:28
mkfs.bfs
26.59
KB
-rwxr-xr-x
2020-01-27 15:28
mkfs.cramfs
34.63
KB
-rwxr-xr-x
2020-01-27 15:28
mkfs.ext2
103.9
KB
-rwxr-xr-x
2020-01-22 15:42
mkfs.ext3
103.9
KB
-rwxr-xr-x
2020-01-22 15:42
mkfs.ext4
103.9
KB
-rwxr-xr-x
2020-01-22 15:42
mkfs.ext4dev
103.9
KB
-rwxr-xr-x
2020-01-22 15:42
mkfs.fat
26.49
KB
-rwxr-xr-x
2016-05-26 14:21
mkfs.minix
75.11
KB
-rwxr-xr-x
2020-01-27 15:28
mkfs.msdos
26.49
KB
-rwxr-xr-x
2016-05-26 14:21
mkfs.ntfs
82.11
KB
-rwxr-xr-x
2019-03-21 22:37
mkfs.vfat
26.49
KB
-rwxr-xr-x
2016-05-26 14:21
mkfs.xfs
355.68
KB
-rwxr-xr-x
2017-09-08 22:24
mkhomedir_helper
18.41
KB
-rwxr-xr-x
2020-10-01 02:36
mkntfs
82.11
KB
-rwxr-xr-x
2019-03-21 22:37
mkswap
71.23
KB
-rwxr-xr-x
2020-01-27 15:28
modinfo
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
modprobe
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
mount.cifs
34.77
KB
-rwsr-xr-x
2017-03-06 14:02
mount.fuse
9.99
KB
-rwxr-xr-x
2016-07-12 09:03
mount.lowntfs-3g
102.67
KB
-rwxr-xr-x
2019-03-21 22:37
mount.ntfs
138.7
KB
-rwxr-xr-x
2019-03-21 22:37
mount.ntfs-3g
138.7
KB
-rwxr-xr-x
2019-03-21 22:37
mount.vmhgfs
42.8
KB
-rwxr-xr-x
2018-05-09 01:51
nameif
14.47
KB
-rwxr-xr-x
2014-06-30 15:19
ntfsclone
54.11
KB
-rwxr-xr-x
2019-03-21 22:37
ntfscp
34.1
KB
-rwxr-xr-x
2019-03-21 22:37
ntfslabel
26.1
KB
-rwxr-xr-x
2019-03-21 22:37
ntfsresize
70.11
KB
-rwxr-xr-x
2019-03-21 22:37
ntfsundelete
50.1
KB
-rwxr-xr-x
2019-03-21 22:37
on_ac_power
2.2
KB
-rwxr-xr-x
2009-12-02 09:57
pam_extrausers_chkpwd
34.8
KB
-rwxr-sr-x
2020-10-01 02:36
pam_extrausers_update
34.73
KB
-rwxr-xr-x
2020-10-01 02:36
pam_tally
10.35
KB
-rwxr-xr-x
2020-10-01 02:36
pam_tally2
14.44
KB
-rwxr-xr-x
2020-10-01 02:36
parted
78.27
KB
-rwxr-xr-x
2018-01-15 13:47
partprobe
10.07
KB
-rwxr-xr-x
2018-01-15 13:47
pivot_root
10.32
KB
-rwxr-xr-x
2020-01-27 15:28
plipconfig
10.2
KB
-rwxr-xr-x
2014-06-30 15:19
plymouthd
83.72
KB
-rwxr-xr-x
2018-05-09 13:59
poweroff
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
pvchange
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvck
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvcreate
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvdisplay
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvmove
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvremove
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvresize
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvs
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
pvscan
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
rarp
29.1
KB
-rwxr-xr-x
2014-06-30 15:19
raw
14.37
KB
-rwxr-xr-x
2020-01-27 15:28
reboot
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
regdbdump
6.13
KB
-rwxr-xr-x
2014-11-18 15:57
request-key
17.99
KB
-rwxr-xr-x
2015-12-10 17:41
resize2fs
51.11
KB
-rwxr-xr-x
2020-01-22 15:42
resolvconf
4.75
KB
-rwxr-xr-x
2019-05-06 10:39
rmmod
147.07
KB
-rwxr-xr-x
2018-11-12 23:07
route
56.67
KB
-rwxr-xr-x
2014-06-30 15:19
rtacct
36.59
KB
-rwxr-xr-x
2019-04-16 14:37
rtmon
42.59
KB
-rwxr-xr-x
2019-04-16 14:37
runlevel
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
runuser
30.98
KB
-rwxr-xr-x
2020-01-27 15:28
setcap
10.3
KB
-rwxr-xr-x
2015-10-23 23:11
setvtrgb
10.41
KB
-rwxr-xr-x
2016-09-22 19:33
sfdisk
92.07
KB
-rwxr-xr-x
2020-01-27 15:28
sgdisk
166.17
KB
-rwxr-xr-x
2016-02-07 11:06
shadowconfig
885
B
-rwxr-xr-x
2019-03-26 20:34
shutdown
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
slattach
33.13
KB
-rwxr-xr-x
2014-06-30 15:19
start-stop-daemon
31.77
KB
-rwxr-xr-x
2021-04-20 22:48
sulogin
43.12
KB
-rwxr-xr-x
2020-01-27 15:28
swaplabel
14.43
KB
-rwxr-xr-x
2020-01-27 15:28
swapoff
18.58
KB
-rwxr-xr-x
2020-01-27 15:28
swapon
43.25
KB
-rwxr-xr-x
2020-01-27 15:28
switch_root
14.46
KB
-rwxr-xr-x
2020-01-27 15:28
sysctl
22.51
KB
-rwxr-xr-x
2020-03-05 13:43
tc
326.1
KB
-rwxr-xr-x
2019-04-16 14:37
telinit
648.38
KB
-rwxr-xr-x
2021-04-02 17:51
tipc
42.38
KB
-rwxr-xr-x
2019-04-16 14:37
tune2fs
75.55
KB
-rwxr-xr-x
2020-01-22 15:42
udevadm
438.61
KB
-rwxr-xr-x
2021-04-02 17:51
unix_chkpwd
34.77
KB
-rwxr-sr-x
2020-10-01 02:36
unix_update
34.7
KB
-rwxr-xr-x
2020-10-01 02:36
ureadahead
34.3
KB
-rwxr-xr-x
2019-04-23 17:23
vconfig
10.24
KB
-rwxr-xr-x
2018-05-10 16:19
veritysetup
31.91
KB
-rwxr-xr-x
2017-09-06 12:08
vgcfgbackup
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgcfgrestore
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgchange
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgck
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgconvert
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgcreate
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgdisplay
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgexport
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgextend
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgimport
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgimportclone
9.4
KB
-rwxr-xr-x
2016-04-16 09:57
vgmerge
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgmknodes
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgreduce
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgremove
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgrename
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgs
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgscan
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
vgsplit
1.45
MB
-rwxr-xr-x
2016-04-16 09:58
wipefs
30.73
KB
-rwxr-xr-x
2020-01-27 15:28
xfs_repair
532.02
KB
-rwxr-xr-x
2017-09-08 22:24
xtables-multi
85.77
KB
-rwxr-xr-x
2016-02-19 16:21
zramctl
75.26
KB
-rwxr-xr-x
2020-01-27 15:28
Save
Rename
#!/bin/bash # # Copyright (C) 2004-2009 Red Hat, Inc. All rights reserved. # # This file is part of the lvm2 package. # # This copyrighted material is made available to anyone wishing to use, # modify, copy, or redistribute it subject to the terms and conditions # of the GNU General Public License v.2. # # You should have received a copy of the GNU General Public License # along with this program; if not, write to the Free Software Foundation, # Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA # # Edit an lvm.conf file to adjust various properties # # cluster with clvmd and/or locking lib? HANDLE_CLUSTER=0 # cluster without clvmd? HANDLE_HALVM=0 # also enable services appropriately (lvmetad, clvmd)? HANDLE_SERVICES=0 # also enable cmirrord service in addition? HANDLE_MIRROR_SERVICE=0 # also start/start services in addition to enabling/disabling them? START_STOP_SERVICES=0 function usage { echo "Usage: $0 <command>" echo "" echo "Commands:" echo "Enable clvm: --enable-cluster [--lockinglibdir <dir>] [--lockinglib <lib>]" echo "Disable clvm: --disable-cluster" echo "Enable halvm: --enable-halvm" echo "Disable halvm: --disable-halvm" echo "Set locking library: --lockinglibdir <dir> [--lockinglib <lib>]" echo "" echo "Global options:" echo "Config file location: --file <configfile>" echo "Set services: --services [--mirrorservice] [--startstopservices]" echo "" echo "Use the separate command 'lvmconfig' to display configuration information" } function set_default_use_lvmetad_var { eval $(lvm dumpconfig --type default global/use_lvmetad 2>/dev/null) if [ "$?" != "0" ]; then USE_LVMETAD=0 else USE_LVMETAD=$use_lvmetad fi } function parse_args { while [ -n "$1" ]; do case $1 in --enable-cluster) LOCKING_TYPE=3 USE_LVMETAD=0 HANDLE_CLUSTER=1 shift ;; --disable-cluster) LOCKING_TYPE=1 set_default_use_lvmetad_var HANDLE_CLUSTER=1 shift ;; --enable-halvm) LOCKING_TYPE=1 USE_LVMETAD=0 HANDLE_HALVM=1 shift ;; --disable-halvm) LOCKING_TYPE=1 set_default_use_lvmetad_var HANDLE_HALVM=1 shift ;; --lockinglibdir) if [ -n "$2" ]; then LOCKINGLIBDIR=$2 shift 2 else usage exit 1 fi HANDLE_CLUSTER=1 ;; --lockinglib) if [ -n "$2" ]; then LOCKINGLIB=$2 shift 2 else usage exit 1 fi HANDLE_CLUSTER=1 ;; --file) if [ -n "$2" ]; then CONFIGFILE=$2 shift 2 else usage exit 1 fi ;; --services) HANDLE_SERVICES=1 shift ;; --mirrorservice) HANDLE_MIRROR_SERVICE=1 shift ;; --startstopservices) START_STOP_SERVICES=1 shift ;; *) usage exit 1 esac done if [ "$LOCKINGLIBDIR" -o "$LOCKINGLIB" ]; then LOCKING_TYPE=2 USE_LVMETAD=0 fi } function validate_args { [ -z "$CONFIGFILE" ] && CONFIGFILE="/etc/lvm/lvm.conf" if [ ! -f "$CONFIGFILE" ] then echo "$CONFIGFILE does not exist" exit 10 fi if [ "$HANDLE_CLUSTER" = "1" -a "$HANDLE_HALVM" = "1" ]; then echo "Either HA LVM or cluster method may be used at one time" exit 18 fi if [ "$HANDLE_SERVICES" = "0" ]; then if [ "$HANDLE_MIRROR_SERVICE" = "1" ]; then echo "--mirrorservice may be used only with --services" exit 19 fi if [ "$START_STOP_SERVICES" = "1" ]; then echo "--startstopservices may be used only with --services" exit 19 fi fi if [ -z "$LOCKING_TYPE" ] && [ -z "$LOCKINGLIBDIR" ]; then usage exit 1 fi if [ -n "$LOCKINGLIBDIR" ]; then if [ "${LOCKINGLIBDIR:0:1}" != "/" ] then echo "Prefix must be an absolute path name (starting with a /)" exit 12 fi if [ -n "$LOCKINGLIB" ] && [ ! -f "$LOCKINGLIBDIR/$LOCKINGLIB" ] then echo "$LOCKINGLIBDIR/$LOCKINGLIB does not exist, did you do a \"make install\" ?" exit 11 fi fi if [ "$LOCKING_TYPE" = "1" ] && [ -n "$LOCKINGLIBDIR" -o -n "$LOCKINGLIB" ]; then echo "Superfluous locking lib parameter, ignoring" fi } umask 0077 parse_args "$@" validate_args SCRIPTFILE=/etc/lvm/.lvmconf-script.tmp TMPFILE=/etc/lvm/.lvmconf-tmp.tmp # Flags so we know which parts of the file we can replace and which need # adding. These are return codes from grep, so zero means it IS present! have_type=1 have_dir=1 have_library=1 have_use_lvmetad=1 have_global=1 grep -q '^[[:blank:]]*locking_type[[:blank:]]*=' $CONFIGFILE have_type=$? grep -q '^[[:blank:]]*library_dir[[:blank:]]*=' $CONFIGFILE have_dir=$? grep -q '^[[:blank:]]*locking_library[[:blank:]]*=' $CONFIGFILE have_library=$? grep -q '^[[:blank:]]*use_lvmetad[[:blank:]]*=' $CONFIGFILE have_use_lvmetad=$? # Those options are in section "global {" so we must have one if any are present. if [ "$have_type" = "0" -o "$have_dir" = "0" -o "$have_library" = "0" -o "$have_use_lvmetad" = "0" ] then # See if we can find it... grep -q '^[[:blank:]]*global[[:blank:]]*{' $CONFIGFILE have_global=$? if [ "$have_global" = "1" ] then echo "global keys but no 'global {' found, can't edit file" exit 13 fi fi if [ "$LOCKING_TYPE" = "2" ] && [ -z "$LOCKINGLIBDIR" ] && [ "$have_dir" = "1" ]; then echo "no library_dir specified in $CONFIGFILE" exit 16 fi # So if we don't have "global {" we need to create one and # populate it if [ "$have_global" = "1" ] then if [ -z "$LOCKING_TYPE" ]; then LOCKING_TYPE=1 fi if [ "$LOCKING_TYPE" = "3" ] || [ "$LOCKING_TYPE" = "2" ]; then cat $CONFIGFILE - <<EOF > $TMPFILE global { # Enable locking for cluster LVM locking_type = $LOCKING_TYPE library_dir = "$LOCKINGLIBDIR" # Disable lvmetad in cluster use_lvmetad = 0 EOF if [ $? != 0 ] then echo "failed to create temporary config file, $CONFIGFILE not updated" exit 14 fi if [ -n "$LOCKINGLIB" ]; then cat - <<EOF >> $TMPFILE locking_library = "$LOCKINGLIB" EOF if [ $? != 0 ] then echo "failed to create temporary config file, $CONFIGFILE not updated" exit 16 fi fi cat - <<EOF >> $TMPFILE } EOF fi # if we aren't setting cluster locking, we don't need to create a global section if [ $? != 0 ] then echo "failed to create temporary config file, $CONFIGFILE not updated" exit 17 fi else # # We have a "global {" section, so add or replace the # locking entries as appropriate # if [ -n "$LOCKING_TYPE" ]; then if [ "$have_type" = "0" ] then SEDCMD=" s/^[[:blank:]]*locking_type[[:blank:]]*=.*/\ \ \ \ locking_type = $LOCKING_TYPE/g" else SEDCMD=" /global[[:blank:]]*{/a\ \ \ \ locking_type = $LOCKING_TYPE" fi fi if [ -n "$LOCKINGLIBDIR" ]; then if [ "$have_dir" = "0" ] then SEDCMD="${SEDCMD}\ns'^[[:blank:]]*library_dir[[:blank:]]*=.*'\ \ \ \ library_dir = \"$LOCKINGLIBDIR\"'g" else SEDCMD="${SEDCMD}\n/global[[:blank:]]*{/a\ \ \ \ library_dir = \"$LOCKINGLIBDIR\"" fi fi if [ -n "$LOCKINGLIB" ]; then if [ "$have_library" = "0" ] then SEDCMD="${SEDCMD}\ns/^[[:blank:]]*locking_library[[:blank:]]*=.*/\ \ \ \ locking_library = \"$LOCKINGLIB\"/g" else SEDCMD="${SEDCMD}\n/global[[:blank:]]*{/a\ \ \ \ locking_library = \"$LOCKINGLIB\"" fi fi if [ "$have_use_lvmetad" = "0" ] then SEDCMD="${SEDCMD}\ns'^[[:blank:]]*use_lvmetad[[:blank:]]*=.*'\ \ \ \ use_lvmetad = $USE_LVMETAD'g" else SEDCMD="${SEDCMD}\n/global[[:blank:]]*{/a\ \ \ \ use_lvmetad = $USE_LVMETAD" fi echo -e $SEDCMD > $SCRIPTFILE sed <$CONFIGFILE >$TMPFILE -f $SCRIPTFILE if [ $? != 0 ] then echo "sed failed, $CONFIGFILE not updated" exit 15 fi fi # Now we have a suitably editted config file in a temp place, # backup the original and copy our new one into place. cp $CONFIGFILE $CONFIGFILE.lvmconfold if [ $? != 0 ] then echo "failed to backup old config file, $CONFIGFILE not updated" exit 2 fi cp $TMPFILE $CONFIGFILE if [ $? != 0 ] then echo "failed to copy new config file into place, check $CONFIGFILE is still OK" exit 3 fi rm -f $SCRIPTFILE $TMPFILE function set_service { local type="$1" local action="$2" shift 2 if [ "$type" = "systemd" ]; then if [ "$action" = "activate" ]; then for i in $@; do eval $($SYSTEMCTL_BIN show $i -p LoadState) test "$LoadState" = "loaded" || continue $SYSTEMCTL_BIN enable $i if [ "$START_STOP_SERVICES" = "1" ]; then $SYSTEMCTL_BIN start $i fi done elif [ "$action" = "deactivate" ]; then for i in $@; do eval $($SYSTEMCTL_BIN show $i -p LoadState) test "$LoadState" = "loaded" || continue $SYSTEMCTL_BIN disable $i if [ "$START_STOP_SERVICES" = "1" ]; then $SYSTEMCTL_BIN stop $i fi done fi elif [ "$type" = "sysv" ]; then if [ "$action" = "activate" ]; then for i in $@; do $CHKCONFIG_BIN --list $i > /dev/null || continue $CHKCONFIG_BIN $i on if [ "$START_STOP_SERVICES" = "1" ]; then $SERVICE_BIN $i start fi done elif [ "$action" = "deactivate" ]; then for i in $@; do $CHKCONFIG_BIN --list $i > /dev/null || continue if [ "$START_STOP_SERVICES" = "1" ]; then $SERVICE_BIN $i stop fi $CHKCONFIG_BIN $i off done fi fi } # Start/stop and enable/disable services if needed. if [ "$HANDLE_SERVICES" == "1" ]; then SYSTEMCTL_BIN=$(which systemctl 2>/dev/null) CHKCONFIG_BIN=$(which chkconfig 2>/dev/null) SERVICE_BIN=$(which service 2>/dev/null) # Systemd services if [ -n "$SYSTEMCTL_BIN" ]; then if [ "$USE_LVMETAD" = "0" ]; then set_service systemd deactivate lvm2-lvmetad.service lvm2-lvmetad.socket else set_service systemd activate lvm2-lvmetad.socket fi if [ "$LOCKING_TYPE" = "3" ]; then set_service systemd activate lvm2-cluster-activation.service if [ "$HANDLE_MIRROR_SERVICE" = "1" ]; then set_service activate lvm2-cmirrord.service fi else set_service systemd deactivate lvm2-cluster-activation.service if [ "$HANDLE_MIRROR_SERVICE" = "1" ]; then set_service systemd deactivate lvm2-cmirrord.service fi fi # System V init scripts elif [ -n "$SERVICE_BIN" -a -n "$CHKCONFIG_BIN" ]; then if [ "$USE_LVMETAD" = "0" ]; then set_service sysv deactivate lvm2-lvmetad else set_service sysv activate lvm2-lvmetad fi if [ "$LOCKING_TYPE" = "3" ]; then set_service sysv activate clvmd if [ "$HANDLE_MIRROR_SERVICE" = "1" ]; then set_service sysv activate cmirrord fi else set_service sysv deactivate clvmd if [ "$HANDLE_MIRROR_SERVICE" = "1" ]; then set_service sysv deactivate cmirrord fi fi # None of the service tools found, error out else echo "Missing tools to handle services" exit 20 fi fi